/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.22 Revision 1.37
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.22 2009/06/04 09:29:54 scarabeus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.37 2010/05/17 01:16:39 reavertm Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
14 14
15inherit kde4-base versionator 15inherit kde4-base versionator
16 16
17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm 17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
18 18
19if [[ -z ${KMNAME} ]]; then
20 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild" 19[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
21fi
22 20
23case ${KDEBASE} in
24 kde-base)
25 HOMEPAGE="http://www.kde.org/"
26 LICENSE="GPL-2"
27 ;;
28 koffice)
29 HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2"
31 ;;
32esac
33
34# remove this codeblock when 4.2.3 is dropped
35if [[ ${PV} = "4.2.3" ]]; then
36 [[ ${PN} != khelpcenter ]] && has doc ${IUSE//+} \
37 RDEPEND="${RDEPEND} doc? ( >=kde-base/khelpcenter-${PV}:${SLOT}[kdeprefix=] )"
38else
39# Add khelpcenter dependency when installing handbooks
40if [[ ${PN} != khelpcenter ]] && has handbook ${IUSE//+}; then
41 RDEPEND="${RDEPEND}
42 handbook? ( >=kde-base/khelpcenter-${PV}:${SLOT}[kdeprefix=] )
43 "
44fi
45fi
46# Add dependencies that all packages in a certain module share. 21# Add dependencies that all packages in a certain module share.
47case ${KMNAME} in 22case ${KMNAME} in
48 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics) 23 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
49 DEPEND="${DEPEND} 24 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
50 >=kde-base/qimageblitz-0.0.4
51 "
52 RDEPEND="${RDEPEND}
53 >=kde-base/qimageblitz-0.0.4
54 "
55 ;; 25 ;;
56 kdenetwork) 26 kdepim|kdepim-runtime)
57 DEPEND="${DEPEND} 27 ! slot_is_at_least 4.4 ${SLOT} && COMMONDEPEND+=" $(add_kdebase_dep kdepimlibs)"
58 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
59 "
60 RDEPEND="${RDEPEND}
61 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
62 "
63 ;;
64 kdepim)
65 DEPEND="${DEPEND}
66 dev-libs/boost
67 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
68 "
69 RDEPEND="${RDEPEND}
70 dev-libs/boost
71 >=kde-base/kdepimlibs-${PV}:${SLOT}[kdeprefix=]
72 "
73 case ${PN} in 28 case ${PN} in
74 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker) 29 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
75 IUSE="+kontact" 30 IUSE+=" +kontact"
76 RDEPEND="${RDEPEND} 31 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
77 kontact? ( >=kde-base/kontactinterfaces-${PV}:${SLOT}[kdeprefix=] )
78 "
79 ;; 32 ;;
80 esac 33 esac
81 ;; 34 ;;
82 kdegames) 35 kdegames)
83 if [[ ${PN} != libkdegames ]]; then 36 if [[ ${PN} != libkdegames ]]; then
84 DEPEND="${DEPEND} 37 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
85 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
86 "
87 RDEPEND="${RDEPEND}
88 >=kde-base/libkdegames-${PV}:${SLOT}[kdeprefix=]
89 "
90 fi 38 fi
91 ;; 39 ;;
92 koffice) 40 koffice)
93 [[ ${PN} != koffice-data ]] && IUSE="debug" 41 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
94 RDEPEND="${RDEPEND} 42 RDEPEND+="
95 !app-office/${PN}:0 43 !app-office/${PN}:0
96 !app-office/koffice:0 44 !app-office/koffice:0
97 !app-office/koffice-meta:0 45 !app-office/koffice-meta:0
98 " 46 "
99 if has openexr ${IUSE//+}; then 47 if has openexr ${IUSE//+}; then
100 COMMON_DEPEND="media-gfx/imagemagick[openexr?]" 48 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
101 else 49 else
102 COMMON_DEPEND="media-gfx/imagemagick" 50 COMMONDEPEND+=" media-gfx/imagemagick"
103 fi 51 fi
104 52
105 COMMON_DEPEND="${COMMON_DEPEND} 53 COMMONDEPEND+="
106 dev-cpp/eigen:2 54 dev-cpp/eigen:2
107 media-libs/fontconfig 55 media-libs/fontconfig
108 media-libs/freetype:2 56 media-libs/freetype:2
109 " 57 "
110 DEPEND="${DEPEND} ${COMMON_DEPEND}"
111 RDEPEND="${RDEPEND} ${COMMON_DEPEND}"
112 unset COMMON_DEPEND
113 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then 58 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
114 DEPEND="${DEPEND}
115 >=app-office/koffice-libs-${PV}:${SLOT} 59 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
116 "
117 RDEPEND="${RDEPEND}
118 >=app-office/koffice-libs-${PV}:${SLOT}
119 "
120 fi 60 fi
121 ;; 61 ;;
122esac 62esac
63
64DEPEND+=" ${COMMONDEPEND}"
65RDEPEND+=" ${COMMONDEPEND}"
66unset COMMONDEPEND
123 67
124debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 68debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
125debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 69debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
126 70
127# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc) 71# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
258 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 202 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
259 fi 203 fi
260 else 204 else
261 local abort tarball tarfile f extractlist moduleprefix postfix 205 local abort tarball tarfile f extractlist moduleprefix postfix
262 case ${PV} in 206 case ${PV} in
263 4.2.85|4.2.90) 207 4.[34].8[05] | 4.[34].9[0568])
264 # block for normally packed upstream unstable snapshots 208 # block for normally packed upstream unstable snapshots
265 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 209 KMTARPARAMS+=" --bzip2" # bz2
266 postfix="bz2" 210 postfix="bz2"
267 ;; 211 ;;
268 4.2.9* | 4.2.8* | 4.2.7* | 4.2.6*) 212 4.[34].[6-9]*)
269 KMTARPARAMS="${KMTARPARAMS} --lzma" # lzma 213 # Not passing --xz, as it doesn't work with stable tar
214 KMTARPARAMS+=" --use-compress-program=xz" # xz
270 postfix="lzma" 215 postfix="xz"
271 ;; 216 ;;
272 *) 217 *)
273 KMTARPARAMS="${KMTARPARAMS} --bzip2" # bz2 218 KMTARPARAMS+=" --bzip2" # bz2
274 postfix="bz2" 219 postfix="bz2"
275 ;; 220 ;;
276 esac 221 esac
277 case ${KMNAME} in 222 case ${KMNAME} in
278 kdebase-apps) 223 kdebase-apps)
279 # kdebase/apps -> kdebasa-apps 224 # kdebase/apps -> kdebase-apps
280 tarball="kdebase-${PV}.tar.${postfix}" 225 tarball="kdebase-${PV}.tar.${postfix}"
281 # Go one level deeper for kdebase-apps in tarballs 226 # Go one level deeper for kdebase-apps in tarballs
282 moduleprefix=apps/ 227 moduleprefix=apps/
283 KMTARPARAMS="${KMTARPARAMS} --transform=s|apps/||" 228 KMTARPARAMS+=" --transform=s|apps/||"
284 ;; 229 ;;
285 *) 230 *)
286 # Create tarball name from module name (this is the default) 231 # Create tarball name from module name (this is the default)
287 tarball="${KMNAME}-${PV}.tar.${postfix}" 232 tarball="${KMNAME}-${PV}.tar.${postfix}"
288 ;; 233 ;;
289 esac 234 esac
290 235
291 # Full patch to source tarball 236 # Full path to source tarball
292 tarfile="${DISTDIR}/${tarball}" 237 tarfile="${DISTDIR}/${tarball}"
293 238
294 # Detect real toplevel dir from tarball name - it will be used upon extraction 239 # Detect real toplevel dir from tarball name - it will be used upon extraction
295 # and in __list_needed_subdirectories 240 # and in __list_needed_subdirectories
296 topdir="${tarball%.tar.*}/" 241 topdir="${tarball%.tar.*}/"
300 kde4-meta_create_extractlists 245 kde4-meta_create_extractlists
301 246
302 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 247 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
303 AUTHORS COPYING INSTALL README NEWS ChangeLog 248 AUTHORS COPYING INSTALL README NEWS ChangeLog
304 do 249 do
305 extractlist="${extractlist} ${topdir}${moduleprefix}${f}" 250 extractlist+=" ${topdir}${moduleprefix}${f}"
306 done 251 done
307 extractlist="${extractlist} $(__list_needed_subdirectories)" 252 extractlist+=" $(__list_needed_subdirectories)"
308 253
309 pushd "${WORKDIR}" > /dev/null 254 pushd "${WORKDIR}" > /dev/null
310 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2 255 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} >&2
311 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null 256 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} 2> /dev/null
312 257
342# KMEXTRACTONLY and KMTARPARAMS. 287# KMEXTRACTONLY and KMTARPARAMS.
343kde4-meta_create_extractlists() { 288kde4-meta_create_extractlists() {
344 debug-print-function ${FUNCNAME} "$@" 289 debug-print-function ${FUNCNAME} "$@"
345 290
346 # TODO change to KMEXTRA for more strict check 291 # TODO change to KMEXTRA for more strict check
347 # remvove 4.2.3 check when dropped
348 if [[ ${PV} = "4.2.3" ]]; then
349 if has doc ${IUSE//+} && use doc && [[ -n ${KMMODULE} ]]; then
350 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}"
351 fi
352 else
353 if has handbook ${IUSE//+} && use handbook && [[ -n ${KMMODULE} ]]; then 292 if has handbook ${IUSE//+} && use handbook && [[ -n ${KMMODULE} ]]; then
354 # We use the basename of $KMMODULE because $KMMODULE can contain 293 # We use the basename of $KMMODULE because $KMMODULE can contain
355 # the path to the module subdirectory. 294 # the path to the module subdirectory.
356 KMEXTRA_NONFATAL="${KMEXTRA_NONFATAL} doc/${KMMODULE##*/}" 295 KMEXTRA_NONFATAL+="
357 fi 296 doc/${KMMODULE##*/}"
358 fi 297 fi
359 298
360 # Add some CMake-files to KMEXTRACTONLY. 299 # Add some CMake-files to KMEXTRACTONLY.
361 # Note that this actually doesn't include KMEXTRA handling. 300 # Note that this actually doesn't include KMEXTRA handling.
362 # In those cases you should care to add the relevant files to KMEXTRACTONLY 301 # In those cases you should care to add the relevant files to KMEXTRACTONLY
363 case ${KMNAME} in 302 case ${KMNAME} in
364 kdebase) 303 kdebase)
365 KMEXTRACTONLY="${KMEXTRACTONLY} 304 KMEXTRACTONLY+="
366 apps/config-apps.h.cmake 305 apps/config-apps.h.cmake
367 apps/ConfigureChecks.cmake" 306 apps/ConfigureChecks.cmake"
368 ;; 307 ;;
369 kdebase-apps) 308 kdebase-apps)
370 KMEXTRACTONLY="${KMEXTRACTONLY} 309 KMEXTRACTONLY+="
371 config-apps.h.cmake 310 config-apps.h.cmake
372 ConfigureChecks.cmake" 311 ConfigureChecks.cmake"
373 ;; 312 ;;
374 kdebase-runtime) 313 kdebase-runtime)
375 KMEXTRACTONLY="${KMEXTRACTONLY} 314 KMEXTRACTONLY+="
376 config-runtime.h.cmake" 315 config-runtime.h.cmake"
377 ;; 316 ;;
378 kdebase-workspace) 317 kdebase-workspace)
379 KMEXTRACTONLY="${KMEXTRACTONLY} 318 KMEXTRACTONLY+="
380 config-unix.h.cmake 319 config-unix.h.cmake
381 ConfigureChecks.cmake 320 ConfigureChecks.cmake
382 config-workspace.h.cmake 321 config-workspace.h.cmake
383 config-X11.h.cmake 322 config-X11.h.cmake
384 startkde.cmake 323 startkde.cmake
385 KDE4WorkspaceConfig.cmake.in" 324 KDE4WorkspaceConfig.cmake.in"
386 ;; 325 ;;
387 kdegames) 326 kdegames)
388 if [[ ${PN} != libkdegames ]]; then 327 if [[ ${PN} != libkdegames ]]; then
389 KMEXTRACTONLY="${KMEXTRACTONLY} 328 KMEXTRACTONLY+="
390 libkdegames" 329 libkdegames/"
330 KMLOADLIBS="${KMLOADLIBS} libkdegames"
391 fi 331 fi
392 ;; 332 ;;
393 kdepim) 333 kdepim)
394 if [[ ${PN} != libkdepim ]]; then 334 if [[ ${PN} != libkdepim ]]; then
395 KMEXTRACTONLY="${KMEXTRACTONLY} 335 KMEXTRACTONLY+="
396 libkdepim" 336 libkdepim/"
397 fi 337 fi
398 case ${SLOT} in 338 KMEXTRACTONLY+="
399 4.3|live)
400 KMEXTRACTONLY="${KMEXTRACTONLY}
401 kdepim-version.h
402 config-enterprise.h.cmake" 339 config-enterprise.h.cmake
403 ;;
404 esac
405 KMEXTRACTONLY="${KMEXTRACTONLY}
406 kleopatra/ConfigureChecks.cmake" 340 kleopatra/ConfigureChecks.cmake"
341 if slot_is_at_least 4.5 ${SLOT}; then
342 KMEXTRACTONLY+="
343 CTestCustom.cmake
344 kdepim-version.h.cmake"
345 else
346 KMEXTRACTONLY+="
347 kdepim-version.h"
348 fi
407 if has kontact ${IUSE//+} && use kontact; then 349 if has kontact ${IUSE//+} && use kontact; then
350 KMEXTRA+="
408 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 351 kontact/plugins/${PLUGINNAME:-${PN}}/"
409 KMEXTRACTONLY="${KMEXTRACTONLY} kontactinterfaces/" 352 if ! slot_is_at_least 4.4 ${SLOT}; then
353 KMEXTRACTONLY+="
354 kontactinterfaces/"
410 fi 355 fi
356 fi
357 ;;
358 kdeutils)
359 KMEXTRACTONLY+="
360 kdeutils-version.h"
411 ;; 361 ;;
412 koffice) 362 koffice)
413 KMEXTRACTONLY="${KMEXTRACTONLY} 363 KMEXTRACTONLY+="
414 config-endian.h.cmake 364 config-endian.h.cmake
415 filters/config-filters.h.cmake 365 filters/config-filters.h.cmake
416 config-openctl.h.cmake
417 config-openexr.h.cmake 366 config-openexr.h.cmake
418 config-opengl.h.cmake 367 config-opengl.h.cmake
419 config-prefix.h.cmake" 368 config-prefix.h.cmake
369 "
370 case ${PV} in
371 2.0.*)
372 KMEXTRACTONLY+="
373 config-openctl.h.cmake"
374 ;;
375 esac
420 ;; 376 ;;
421 esac 377 esac
422 # Don't install cmake modules for split ebuilds, to avoid collisions. 378 # Don't install cmake modules for split ebuilds, to avoid collisions.
423 case ${KMNAME} in 379 case ${KMNAME} in
424 kdepim)
425 # No need for unpack since 4.2.86
426 # Remove when 4.2 is wiped out from the tree
427 case ${PV} in
428 4.1*|4.2.0|4.2.1|4.2.2|4.2.3|4.2.4|4.2.85)
429 KMCOMPILEONLY="${KMCOMPILEONLY}
430 cmake/modules/"
431 ;;
432 *) ;;
433 esac
434 ;;
435 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics) 380 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
436 case ${PN} in 381 case ${PN} in
437 libkdegames|libkdeedu|libkworkspace) 382 libkdegames|libkdeedu|libkworkspace)
438 KMEXTRA="${KMEXTRA} 383 KMEXTRA+="
439 cmake/modules/" 384 cmake/modules/"
440 ;; 385 ;;
441 *) 386 *)
442 KMCOMPILEONLY="${KMCOMPILEONLY} 387 KMCOMPILEONLY+="
443 cmake/modules/" 388 cmake/modules/"
444 ;; 389 ;;
445 esac 390 esac
446 ;; 391 ;;
447 esac 392 esac
452__list_needed_subdirectories() { 397__list_needed_subdirectories() {
453 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist 398 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
454 399
455 # We expand KMEXTRA by adding CMakeLists.txt files 400 # We expand KMEXTRA by adding CMakeLists.txt files
456 kmextra="${KMEXTRA}" 401 kmextra="${KMEXTRA}"
457 [[ ${1} != fatal ]] && kmextra="${kmextra} ${KMEXTRA_NONFATAL}" 402 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
458 for i in ${kmextra}; do 403 for i in ${kmextra}; do
459 kmextra_expanded="${kmextra_expanded} ${i}" 404 kmextra_expanded+=" ${i}"
460 j=$(dirname ${i}) 405 j=$(dirname ${i})
461 while [[ ${j} != "." ]]; do 406 while [[ ${j} != "." ]]; do
462 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 407 kmextra_expanded+=" ${j}/CMakeLists.txt";
463 j=$(dirname ${j}) 408 j=$(dirname ${j})
464 done 409 done
465 done 410 done
466 411
467 # Expand KMMODULE 412 # Expand KMMODULE
468 if [[ -n ${KMMODULE} ]]; then 413 if [[ -n ${KMMODULE} ]]; then
469 kmmodule_expanded="${KMMODULE}" 414 kmmodule_expanded="${KMMODULE}"
470 j=$(dirname ${KMMODULE}) 415 j=$(dirname ${KMMODULE})
471 while [[ ${j} != "." ]]; do 416 while [[ ${j} != "." ]]; do
472 kmmodule_expanded="${kmmodule_expanded} ${j}/CMakeLists.txt"; 417 kmmodule_expanded+=" ${j}/CMakeLists.txt";
473 j=$(dirname ${j}) 418 j=$(dirname ${j})
474 done 419 done
475 fi 420 fi
476 421
477 # Expand KMCOMPILEONLY 422 # Expand KMCOMPILEONLY
478 for i in ${KMCOMPILEONLY}; do 423 for i in ${KMCOMPILEONLY}; do
479 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 424 kmcompileonly_expanded+=" ${i}"
480 j=$(dirname ${i}) 425 j=$(dirname ${i})
481 while [[ ${j} != "." ]]; do 426 while [[ ${j} != "." ]]; do
482 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 427 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
483 j=$(dirname ${j}) 428 j=$(dirname ${j})
484 done 429 done
485 done 430 done
486 431
487 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 432 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
491 # Create final list of stuff to extract 436 # Create final list of stuff to extract
492 # We append topdir only when specified (usually for tarballs) 437 # We append topdir only when specified (usually for tarballs)
493 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 438 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
494 ${KMEXTRACTONLY} 439 ${KMEXTRACTONLY}
495 do 440 do
496 extractlist="${extractlist} ${topdir}${moduleprefix}${i}" 441 extractlist+=" ${topdir}${moduleprefix}${i}"
497 done 442 done
498 443
499 echo ${extractlist} 444 echo ${extractlist}
500} 445}
501 446
525 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 470 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
526 fi 471 fi
527 done 472 done
528} 473}
529 474
530# FIXME: add description
531# @FUNCTION: kde4-meta_change_cmakelists 475# @FUNCTION: kde4-meta_change_cmakelists
532# @DESCRIPTION: 476# @DESCRIPTION:
477# Adjust CMakeLists.txt to comply to our splitting.
533kde4-meta_change_cmakelists() { 478kde4-meta_change_cmakelists() {
534 debug-print-function ${FUNCNAME} "$@" 479 debug-print-function ${FUNCNAME} "$@"
535 480
536 pushd "${S}" > /dev/null 481 pushd "${S}" > /dev/null
537 482
538 comment_all_add_subdirectory ./ 483 comment_all_add_subdirectory ./
539 484
540 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 485 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
541 if [[ -f "${S}"/CMakeLists.txt ]]; then 486 if [[ -f CMakeLists.txt ]]; then
542 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 487 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
543 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \ 488 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
544 -i "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 489 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
545 fi 490 fi
546 491
547 if [[ -z ${KMNOMODULE} ]]; then 492 if [[ -z ${KMNOMODULE} ]]; then
548 # Restore "add_subdirectory" in $KMMODULE subdirectories 493 # Restore "add_subdirectory" in $KMMODULE subdirectories
549 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 494 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
495 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
550 die "${LINENO}: died in KMMODULE section" 496 die "${LINENO}: died in KMMODULE section"
551 _change_cmakelists_parent_dirs ${KMMODULE} 497 _change_cmakelists_parent_dirs ${KMMODULE}
552 fi 498 fi
553 499
554 local i 500 local i
555 501
556 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY 502 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
557 for i in ${KMEXTRACTONLY}; do 503 for i in ${KMEXTRACTONLY}; do
558 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then 504 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
559 sed -i -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \ 505 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
506 -i ${i}/../CMakeLists.txt || \
560 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}" 507 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
561 fi 508 fi
562 done 509 done
563 510
564 # KMCOMPILEONLY 511 # KMCOMPILEONLY
586 # KMEXTRA_NONFATAL section 533 # KMEXTRA_NONFATAL section
587 for i in ${KMEXTRA_NONFATAL}; do 534 for i in ${KMEXTRA_NONFATAL}; do
588 if [[ -d "${S}"/${i} ]]; then 535 if [[ -d "${S}"/${i} ]]; then
589 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 536 find "${S}"/${i} -name CMakeLists.txt -print0 | \
590 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 537 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
591 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 538 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
592 _change_cmakelists_parent_dirs ${i} 539 _change_cmakelists_parent_dirs ${i}
593 fi 540 fi
594 done 541 done
595 542
596 case ${KMNAME} in 543 case ${KMNAME} in
597 kdebase-workspace) 544 kdebase-workspace)
598 # COLLISION PROTECT section 545 # COLLISION PROTECT section
599 # Install the startkde script just once, as a part of kde-base/kdebase-startkde, 546 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
600 # not as a part of every package. 547 # not as a part of every package.
601 if [[ ${PN} != kdebase-startkde && -f "${S}"/CMakeLists.txt ]]; then 548 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
602 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 549 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
603 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 550 sed -e '/startkde/s/^/#DONOTINSTALL /' \
604 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 551 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
605 fi 552 fi
606 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82 553 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
607 if [[ ${PN} != libkworkspace ]]; then 554 if [[ ${PN} != libkworkspace ]]; then
608 sed -i \
609 -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \ 555 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
610 CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section" 556 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
611 fi 557 fi
612 ;; 558 ;;
613 kdebase-runtime) 559 kdebase-runtime)
614 # COLLISION PROTECT section 560 # COLLISION PROTECT section
615 # Only install the kde4 script as part of kde-base/kdebase-data 561 # Only install the kde4 script as part of kde-base/kdebase-data
616 if [[ ${PN} != kdebase-data && -f "${S}"/CMakeLists.txt ]]; then 562 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
617 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \ 563 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
618 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed" 564 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
619 fi 565 fi
566 ;;
567 kdenetwork)
568 # Disable hardcoded kdepimlibs check
569 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
570 -i CMakeLists.txt || die "failed to disable hardcoded checks"
620 ;; 571 ;;
621 kdepim) 572 kdepim)
573 # Disable hardcoded checks
574 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
575 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
576 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
577 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
578 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
579 -i CMakeLists.txt || die "failed to disable hardcoded checks"
580 # Disable broken or redundant build logic
581 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then
582 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
583 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
584 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
585 fi
586 if ! slot_is_at_least 4.5 ${SLOT}; then
622 case ${PN} in 587 case ${PN} in
623 kaddressbook|kalarm|kmailcvt|kontact|korganizer|korn) 588 kalarm|kmailcvt|kontact|korganizer|korn)
624 sed -i -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \ 589 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
625 -e '/add_custom_target(kmail_xml /,/)/p' "${S}"/kmail/CMakeLists.txt || die "uncommenting xml failed" 590 -e '/add_custom_target(kmail_xml /,/)/p' \
591 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
626 _change_cmakelists_parent_dirs kmail 592 _change_cmakelists_parent_dirs kmail
627 ;; 593 ;;
628 esac 594 esac
595 fi
629 ;; 596 ;;
630 kdewebdev) 597 kdewebdev)
631 # Disable hardcoded kdepimlibs check 598 # Disable hardcoded checks
632 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \ 599 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
633 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \ 600 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
634 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \ 601 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
635 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \ 602 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
636 -i CMakeLists.txt || die "failed to disable hardcoded checks" 603 -i CMakeLists.txt || die "failed to disable hardcoded checks"
637 ;; 604 ;;
638 koffice) 605 koffice)
639 # prevent collisions 606 # Prevent collisions
640 if [[ ${PN} != koffice-data ]]; then 607 if [[ ${PN} != koffice-data ]]; then
641 sed -i -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \ 608 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
642 "${S}"/cmake/modules/CMakeLists.txt || \ 609 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
610 sed -e '/install(.\+config-openexr\.h.\+)/d' \
643 die "${LINENO}: sed died in collision prevention section" 611 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
612 fi
613 # koffice 2.0
614 case ${PV} in
615 2.0.[1-9])
644 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \ 616 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
645 "${S}"/CMakeLists.txt || \ 617 "${S}"/CMakeLists.txt || \
646 die "${LINENO}: sed died in collision prevention section" 618 die "${LINENO}: sed died in collision prevention section"
619 ;;
620 *) ;;
621 esac
622 # koffice 2.1.[8-9][0-9] and 9999
623 case ${PV} in
624 2.1.8[0-9]|2.1.9[0-9]|9999)
625 sed -e '/^option(BUILD/s/ON/OFF/' \
626 -e '/^if(NOT BUILD_kchart/,/^endif(NOT BUILD_kchart/d' \
627 -e '/^if(BUILD_koreport/,/^endif(BUILD_koreport/d' \
628 -e 's/set(SHOULD_BUILD_F_OFFICE TRUE)/set(SHOULD_BUILD_F_OFFICE FALSE)/' \
629 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
630 if [[ ${PN} != koffice-data ]] && [[ ${PV} == 9999 ]]; then
631 sed -e '/config-opengl.h/d' \
632 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
633
647 fi 634 fi
635 ;;
636 *) ;;
637 esac
648 esac 638 esac
649 639
650 popd > /dev/null 640 popd > /dev/null
651} 641}
652 642
655# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split 645# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
656# ebuilds. 646# ebuilds.
657kde4-meta_src_configure() { 647kde4-meta_src_configure() {
658 debug-print-function ${FUNCNAME} "$@" 648 debug-print-function ${FUNCNAME} "$@"
659 649
650 # backwards-compatibility: make mycmakeargs an array, if it isn't already
651 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
652 mycmakeargs=(${mycmakeargs})
653 fi
654
660 # Set some cmake default values here (usually workarounds for automagic deps) 655 # Set some cmake default values here (usually workarounds for automagic deps)
661 case ${KMNAME} in 656 case ${KMNAME} in
662 kdewebdev) 657 kdewebdev)
663 mycmakeargs=" 658 mycmakeargs=(
664 -DWITH_KdepimLibs=OFF 659 -DWITH_KdepimLibs=OFF
665 -DWITH_LibXml2=OFF 660 -DWITH_LibXml2=OFF
666 -DWITH_LibXslt=OFF 661 -DWITH_LibXslt=OFF
667 -DWITH_Boost=OFF 662 -DWITH_Boost=OFF
668 -DWITH_LibTidy=OFF 663 -DWITH_LibTidy=OFF
669 ${mycmakeargs}" 664 "${mycmakeargs[@]}"
665 )
666 ;;
667 koffice)
668 case ${PV} in
669 2.1.8[0-9]|2.1.9[0-9]|9999)
670 if [[ ${PN} != "kchart" ]]; then
671 mycmakeargs=(
672 -DBUILD_koreport=OFF
673 "${mycmakeargs[@]}"
674 )
675 fi
676 ;;
677 esac
670 ;; 678 ;;
671 esac 679 esac
672 680
673 kde4-base_src_configure 681 kde4-base_src_configure
674} 682}
678# General function for compiling split KDE4 applications. 686# General function for compiling split KDE4 applications.
679# Overrides kde4-base_src_compile. 687# Overrides kde4-base_src_compile.
680kde4-meta_src_compile() { 688kde4-meta_src_compile() {
681 debug-print-function ${FUNCNAME} "$@" 689 debug-print-function ${FUNCNAME} "$@"
682 690
683 kde4-base_src_compile 691 kde4-base_src_compile "$@"
684} 692}
685 693
686# @FUNCTION: kde4-meta_src_test 694# @FUNCTION: kde4-meta_src_test
687# @DESCRIPTION: 695# @DESCRIPTION:
688# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 696# Currently just calls its equivalent in kde4-base.eclass(5) if
689# ebuilds. 697# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
690kde4-meta_src_test() { 698kde4-meta_src_test() {
691 debug-print-function $FUNCNAME "$@" 699 debug-print-function $FUNCNAME "$@"
692 700
701 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
693 kde4-base_src_test 702 kde4-base_src_test
703 else
704 einfo "Tests disabled"
705 fi
694} 706}
695 707
696# @FUNCTION: kde4-meta_src_install 708# @FUNCTION: kde4-meta_src_install
697# @DESCRIPTION: 709# @DESCRIPTION:
698# Function for installing KDE4 split applications. 710# Function for installing KDE4 split applications.
699kde4-meta_src_install() { 711kde4-meta_src_install() {
700 debug-print-function $FUNCNAME "$@" 712 debug-print-function $FUNCNAME "$@"
701 713
714 # Search ${S}/${KMMODULE} and install common documentation files found
715 local doc
716 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
717 [[ -s "${doc}" ]] && dodoc "${doc}"
718 done
719
702 kde4-base_src_install 720 kde4-base_src_install
703} 721}
704 722
705# @FUNCTION: kde4-meta_src_make_doc
706# @DESCRIPTION:
707# This function searches in ${S}/${KMMODULE},
708# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
709kde4-meta_src_make_doc() {
710 debug-print-function ${FUNCNAME} "$@"
711
712 local doc
713 for doc in AUTHORS ChangeLog* README* NEWS TODO; do
714 [[ -s ${KMMODULE}/${doc} ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}"
715 done
716
717 kde4-base_src_make_doc
718}
719
720# @FUNCTION: kde4-meta_pkg_postinst 723# @FUNCTION: kde4-meta_pkg_postinst
721# @DESCRIPTION: 724# @DESCRIPTION:
722# Display information about application handbook and invoke kbuildsycoca4. 725# Invoke kbuildsycoca4.
723kde4-meta_pkg_postinst() { 726kde4-meta_pkg_postinst() {
724 debug-print-function ${FUNCNAME} "$@" 727 debug-print-function ${FUNCNAME} "$@"
725
726 if has handbook ${IUSE//+} && ! use handbook; then
727 echo
728 einfo "Application handbook for ${PN} has not been installed."
729 einfo "To install handbook, reemerge =${CATEGORY}/${P} with 'handbook' USE flag."
730 echo
731 fi
732 728
733 kde4-base_pkg_postinst 729 kde4-base_pkg_postinst
734} 730}
735 731
736# @FUNCTION: kde4-meta_pkg_postrm 732# @FUNCTION: kde4-meta_pkg_postrm

Legend:
Removed from v.1.22  
changed lines
  Added in v.1.37

  ViewVC Help
Powered by ViewVC 1.1.20